import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { XamRadialGaugeRange as XamRadialGaugeRange_internal } from './XamRadialGaugeRange';
import { IgcRadialGaugeRangeComponent as IgcRadialGaugeRangeComponent } from './igc-radial-gauge-range-component';
export class IgcRadialGaugeRangeCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgcRadialGaugeRangeComponent.$type) {
            IgcRadialGaugeRangeComponent.$type = markType(IgcRadialGaugeRangeComponent, "IgcRadialGaugeRangeComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgcRadialGaugeRangeComponent.$type) {
            IgcRadialGaugeRangeComponent.$type = markType(IgcRadialGaugeRangeComponent, "IgcRadialGaugeRangeComponent");
        }
        let coll = new SyncableObservableCollection$2(IgcRadialGaugeRangeComponent.$type, XamRadialGaugeRange_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgcRadialGaugeRangeComponent._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
