import { __extends } from "tslib";
import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { XamRadialGaugeRange as XamRadialGaugeRange_internal } from './XamRadialGaugeRange';
import { IgcRadialGaugeRangeComponent as IgcRadialGaugeRangeComponent } from './igc-radial-gauge-range-component';
var IgcRadialGaugeRangeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcRadialGaugeRangeCollection, _super);
    function IgcRadialGaugeRangeCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgcRadialGaugeRangeComponent.$type) {
            IgcRadialGaugeRangeComponent.$type = markType(IgcRadialGaugeRangeComponent, "IgcRadialGaugeRangeComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgcRadialGaugeRangeCollection.prototype._createInnerColl = function () {
        if (!IgcRadialGaugeRangeComponent.$type) {
            IgcRadialGaugeRangeComponent.$type = markType(IgcRadialGaugeRangeComponent, "IgcRadialGaugeRangeComponent");
        }
        var coll = new SyncableObservableCollection$2(IgcRadialGaugeRangeComponent.$type, XamRadialGaugeRange_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgcRadialGaugeRangeComponent._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgcRadialGaugeRangeCollection;
}(IgCollection));
export { IgcRadialGaugeRangeCollection };
